#******************************************************************************
# vO: P010804.R                                                     *
# eLXg̏: Ṕ@SAS/RpX͎̉                         *
# eLXg̐: W߁@X̌                                        *
# gpړI: pʁ|֌W̌osBiΔpj                  *
# Date: 2017/2/3  Version: 1.0                                                *
#******************************************************************************

# ----- o͐ݒ
sink("./p010804.txt")
# ----- Tvf[^荞
d010804.what <- list(drug="", sbpaf=0)
tmp1<-scan(file="./d010804.csv", what=d010804.what)
d010804<-data.frame(tmp1)
d010804$drugc <- factor(d010804$drug)
# ----- contrast̊֐`
usr.contrast.fix <- function(effect,group,contpar)
{
   contxmean <- tapply(effect, factor(group), mean)
   ngun <- length(contxmean)
   contxvar  <- tapply(effect, factor(group), var)
   contxsd   <- sqrt(contxvar)
   contxrows <- tapply(effect, factor(group), length)
   print(contxrows)
   npat <- length(row.names(contpar))
   
   cont.result <- NULL
   for(i in 1:npat){
      aswnume <- 0
      aswdeno <- 0
      df      <- 0
      dn      <- 0
      for(j in 1:ngun){
         aswnume <- aswnume + (contxrows[j] - 1) * contxvar[j]
         aswdeno <- aswdeno + contxrows[j] - 1
         dn      <- dn + contxrows[j]
      }
      AS  <- aswnume / aswdeno
      ASD <- sqrt(AS)
      twnume <- 0
      twdeno <- 0
      for(j in 1:ngun){
         twnume <- twnume + contbase1[i,j] * contxmean[j]
         twdeno <- twdeno + (contbase1[i,j] * contbase1[i,j])/contxrows[j]
      }
      df <- (dn - 1) - (ngun - 1)
      TV <- twnume / sqrt(AS * twdeno)
      pt.val <- 1 - pt(TV,df)
      cont.resultx <- c(AS,df,TV,pt.val)
      cont.result  <- rbind(cont.result,cont.resultx)
   }
   
   cont.result <- as.data.frame(cont.result)
   dimnames(cont.result) <- list(
      row.names(contbase1),
      c("AS","df","TV","pt.val")
   )
   
   all.result <- list(mean=contxmean,var=contxvar,
                      sd=contxsd,dn=contxrows,cont.fix=cont.result)
   all.result
}
# ----- contrastl̍쐬
contbase1  <- c( 3,   1,  -1,  -3,
                 3,  -1,  -1,  -1,
                 5,   1,  -3,  -3,
                 3,   3,  -1,  -5,
                 1,   1,   1,  -3 
)
contbase1 <- data.frame(matrix(contbase1,ncol=4,byrow=T))
# ----- pʁ|֌W̌osBiΔpj
s010804cont.fix <- usr.contrast.fix(effect=d010804$sbpaf,
                               group=d010804$drug,contpar=contbase1)
print(s010804cont.fix)
# ----- o͐Wɖ߂
sink()
