#******************************************************************************
# vO: P020401.R                                                     *
# eLXg̏: Q́@SAS/RpX̗ᐔ݌v                     *
# eLXg̐: S߁@wI                                  *
# gpړI: wIɂėᐔ߂                            *
# Date: 2017/2/3  Version: 1.0                                                *
#******************************************************************************

# ----- o͐ݒ
sink("./p020401.txt")
# ----- ֐` ----- wI̗ᐔ݌v
#  MU1    : 팱̕ϒl
#  MU2    : ΏƖ̕ϒl
#  VAR    : cU
#  BETA   : 2̉ߌ
f020401 <- function(MU1, MU2, VAR, BETA)
{
	DELTA <- MU1 - MU2
	POWER <- 1 - BETA
	P <- sapply(
			2:100,
			function(N, DELTA, VAR)
			{
				THETAL <- (log(0.8)-DELTA) / sqrt(VAR/N) + qt(0.95, 2*N-2)
					THETAU <- (log(1.25)-DELTA) / sqrt(VAR/N) - qt(0.95, 2*N-2)
				pt(THETAU, 2*N-2) - pt(THETAL, 2*N-2)
			},
			DELTA=DELTA, VAR=VAR)
	case <- (2:100)[P >= POWER]
	N <- min(case)
	Pmin <- P[N-1]
	c(MU1=MU1, MU2=MU2, DELTA=DELTA, VAR=VAR, BETA=BETA, N=N, P=Pmin)
}
# ----- vZ
s020401a <- f020401(MU1=1.265, MU2=1.346, VAR=0.1219, BETA=0.2)
print(s020401a)
# ----- o͐Wɖ߂
sink()
