#******************************************************************************
# vO: P010706.R                                                     *
# eLXg̏: Ṕ@SAS/RpX͎̉                         *
# eLXg̐: V߁@dr                                            *
# gpړI: Shirley-Williams(mpgbNłWilliams̑dr)    *
# Date: 2017/2/3  Version: 1.0                                                *
#******************************************************************************

# ----- o͐ݒ
sink("./p010706.txt")
# ----- Tvf[^荞
d010706.what<-list(group=0, resp=0)
tmp1<-scan(file="./d010706.csv",what=d010706.what,sep="")
d010706<-as.data.frame(tmp1)
# ----- Shirley-Williamsk̊֐`
Shirley.Williams <- function(group, resp)
{
   tgrp <- table(group)
   len <- length(tgrp)
   res <- numeric(len-1)
   
   for (i in 2:len){
      rk <- rank(resp[1 <= group & group <= i])
      group2 <- group[1 <= group & group <= i]
      maxR <- max(cumsum(rev(tapply(rk, group2, sum))[-i]) / cumsum(rev(tgrp[2:i])))
      smn <- sum(tgrp[1:i])
      S <- (sum(rk^2) - smn * (smn + 1)^2 / 4) / (smn - 1)
      res[i-1] <- (maxR - sum(rk[group == 1]) / tgrp[1]) / sqrt(S * (1 / tgrp[i] + 1 / tgrp[1]))
   }
   
   return(res)
}
# ----- Shirley-Williams(mpgbNłWilliams̑dr)
Shirley.Williams(d010706$group, d010706$resp)
# ----- o͐Wɖ߂
sink()
