#******************************************************************************
# vO: P010805.R                                                     *
# eLXg̏: Ṕ@SAS/RpX͎̉                         *
# eLXg̐: W߁@X̌                                        *
# gpړI: Mantel-extension@ɂ錟                                      *
# Date: 2017/2/3  Version: 1.0                                                *
#******************************************************************************

# ----- o͐ݒ
sink("./p010805.txt")
# ----- Tvf[^荞
d010805.what<-list(drug=0, efect=0, efectc="", jyuusho=0)
tmp1<-scan(file="./d010805.csv",what=d010805.what)
d010805<-as.data.frame(tmp1)
# ----- Mantel-extension@ɂ錟
s010805tb <- table(d010805$drug, d010805$efect, d010805$jyuusho)

jmax <- length(s010805tb[,1,1]) 
kmax <- length(dimnames(s010805tb)[[3]])

for(k in 1:kmax) {
   print(k)
	print(s010805tb[,,k]) 
	print(chisq.test(s010805tb[,,k]))
}
dj  <- c(1,2,3,4)
Xk  <- rep(0,times=kmax)
Yk  <- rep(0,times=kmax)
Nk  <- rep(0,times=kmax)
dhk <- rep(0,times=kmax)
for(k in 1:kmax) {
   Xk[k]  <- sum(s010805tb[,1,k])
   Yk[k]  <- sum(s010805tb[,2,k])
   Nk[k]  <- Xk[k] + Yk[k]
   dhk[k] <- 0
   for(j in 1:jmax){
      dhk[k] <- dhk[k] + ( (s010805tb[j,1,k]+s010805tb[j,2,k]) * dj[j] )
   }
   dhk[k] <- dhk[k] / Nk[k]
}
TXj <- rep(0,times=jmax)
ej  <- rep(0,times=jmax)
for(j in 1:jmax){
   TXj[j] <- sum(s010805tb[j,1,])
   ej[j]  <- 0
   for(k in 1:kmax){
      ej[j] <- ej[j] + ( (s010805tb[j,1,k]+s010805tb[j,2,k])*Xk[k] ) / Nk[k]
   }
}

nume1 <- 0
for(j in 1:jmax){
   nume1 <- nume1 + ( dj[j] * (TXj[j] - ej[j]) )
}

deno1  <- vector(length=kmax)
deno2  <- vector(length=kmax)
deno3  <- vector(length=kmax)
deno4  <- vector(length=kmax)
denoy  <- 0
for(k in 1:kmax){
	deno1[k] <- Xk[k] * Yk[k]
	deno2[k] <- Nk[k] * (Nk[k] - 1)
	deno3[k] <- 0
	for(j in 1:jmax){
	   deno3[k] <- deno3[k] + dj[j] * dj[j] * (s010805tb[j,1,k] + s010805tb[j,2,k])
	}
	deno4[k] <- Nk[k] * dhk[k] * dhk[k]
}
	for(k in 1:kmax){
	   denoy <- denoy + ( deno1[k] / deno2[k] ) * ( deno3[k] - deno4[k] )
	}
Zv0 <- nume1 / sqrt(denoy)
Zv1 <- Zv0 * Zv0 
Pv1 <- 1- pchisq(Zv1, 1, ncp=0) 
print(Zv1)
print(Pv1)
# ----- o͐Wɖ߂
sink()
